set shell = WScript.CreateObject("WScript.Shell")
'get the %userprofile% in a variable, or else it won't be recognized
userProfile = shell.ExpandEnvironmentStrings( "%userprofile%" )

'used to open incoming file paths
'OPEN_EDITOR_CMD = userProfile & "\eclipse\java-oxygen\eclipse\eclipse.exe ""%1:%2"""
'OPEN_EDITOR_CMD = """C:\Program Files\Notepad++\notepad++.exe"" ""%1"" -n%2"
'OPEN_EDITOR_CMD = """C:\Program Files\Microsoft VS Code\Code.exe"" -g ""%1:%2"""
OPEN_EDITOR_CMD = shell.ExpandEnvironmentStrings( "%windir%" ) & "\system32\notepad.exe ""%1"""

'used to expand "user:" on incoming input
'first it will check if WORKSPACE_LOOKUP contains a replacement for the file
'if the path matches it will expand to WORKSPACE_DIR & WORKSPACE_LOOKUP & lineNumber
'e.g. C:\MyAddOnWorkspace\MyAddOnProject\src\the\requested\file.lua:123
WORKSPACE_DIR = "C:\MyAddOnWorkspace\"

set WORKSPACE_LOOKUP = wscript.createobject( "Scripting.Dictionary" )
'WORKSPACE_LOOKUP.Add "/AddOns/MyAddOn", "MyAddOnProject\src"

'then it will try the USER_DIR
USER_DIR = userProfile & "\Documents\Elder Scrolls Online\live"

'used to prefix the "EsoUI" directory on incoming input. Has to contain the extracted esoui/ folder.
ESOUI_SRC_DIR = "C:\MyAddOnWorkspace\ESOUI\"

function FileExists(path)
    set fso = wscript.createobject( "Scripting.FileSystemObject" )
    FileExists = fso.FileExists(path) 
'    MsgBox "FileExists """ & path & """: " & FileExists, 0, "ESOUI Dev"
end function

function OpenFile(file, line)
    OpenFile = false
    file = Replace(file, "/", "\")
'    MsgBox "Open File """ & file & """ in line """ & line & """", 0, "ESOUI Dev"
    if FileExists(file) then
        dim command
        command = Replace(OPEN_EDITOR_CMD, "%2", line)
        command = Replace(command, "%1", file)
        wscript.createobject( "WScript.Shell" ).run(command)
'        MsgBox "Opened """ & file & """" & vbCrLf & "Command: " & command, 0, "ESOUI Dev"
        OpenFile = true
    end if
end function

function TryOpenUserFile(input)
    TryOpenUserFile = false
    set re = new RegExp

    dim file, line
    re.Pattern = "^user:.+:(\d+)$"
    line = re.Replace(input, "$1")

    dim key
    re.Pattern = "^user:(.+?/.+?)/.+:\d+$"
    key = re.Replace(input, "$1")
    if WORKSPACE_LOOKUP.Exists(key) then
        re.Pattern = "^user:.+?/.+?(/.+):\d+$"
        file = WORKSPACE_DIR & WORKSPACE_LOOKUP(key) & re.Replace(input, "$1")
        if OpenFile(file, line) then
            TryOpenUserFile = true
        end if
    end if

    if not TryOpenUserFile then
        re.Pattern = "^user:(.+):\d+$"
        file = USER_DIR & re.Replace(input, "$1")
        if OpenFile(file, line) then
            TryOpenUserFile = true
        end if
    end if
end function

function TryOpenEsoUIFile(input)
    TryOpenEsoUIFile = false
    set re = new RegExp

    dim file, line
    re.Pattern = "^(EsoUI/.+):\d+$"
    file = ESOUI_SRC_DIR & LCase(re.Replace(input, "$1"))
    re.Pattern = "^EsoUI/.+:(\d+)$"
    line = re.Replace(input, "$1")

    if OpenFile(file, line) then
        TryOpenEsoUIFile = true
    end if
end function

if wscript.arguments.length > 0 then
    dim input
    dim pathToOpen

    'remove the url protocol
    input = Replace(wscript.arguments(0), "esoui-dev:", "")

    'remove quotes so an attacker cannot inject arbitrary commands
    'TODO other stuff we should remove?
    input = Replace(input, """", "")

    if input = "setup" then
        MsgBox "Link handling works!", 48, "ESOUI Dev"
    elseif left(input, 5) = "user:" then
        if not TryOpenUserFile(input) then
            MsgBox "File not found: """ & input & """", 48, "ESOUI Dev"
        end if
    elseif left(input, 5) = "EsoUI" then
        if not TryOpenEsoUIFile(input) then
            MsgBox "File not found: """ & input & """", 48, "ESOUI Dev"
        end if
    else
        MsgBox "Unsupported Input: """ & input & """", 48, "ESOUI Dev"
    end if
end if